\begin{figure}[!h]
	\centering
	\tikzstyle{block}     = [draw, rectangle, minimum height=1cm, minimum width=1.6cm]
	\tikzstyle{big_block}     = [draw, rectangle, minimum height=3cm, minimum width=3cm]
	\tikzstyle{branch}    = [circle, inner sep=0pt, minimum size=1mm, fill=black, draw=black]
	\tikzstyle{connector} = [->, thick]
	\tikzstyle{dummy}     = [inner sep=0pt, minimum size=0pt]
	\tikzstyle{inout}     = []
	\tikzstyle{sum}       = [circle, inner sep=0pt, minimum size=2mm, draw=black, thick]
	\begin{tikzpicture}[auto, node distance=1.6cm, >=stealth']
	\node[block] (K_1) {$\mathbf{K_1}$};
	\node[big_block] (G) [ below right=-1.2cm and 4cm of K_1] {$\mathbf{G}$};
	\node[block] (K_2) [ below right=-1.2cm and -6cm of G] {$\mathbf{K_2}$};
	\node[sum] (s1) [left=of K_1] {};
	\node[inout] (r_1) [left=of s1] {$\mathbf{r_1}$};
	\node[sum] (s2) [below=1.4 of s1] {};
	\node[inout] (r_2) [left=of s2] {$\mathbf{r_2}$};
	\node[dummy] (s22) [below=of s2]{};
	\node[dummy] (d1) [above right=0.1cm and 0.05cm of s1] {};
	\node[dummy] (d2) [above left=-0.64cm and -0.07cm of G] {};
	\node[dummy] (d3) [below left=-0.64cm and -0.07cm of G] {};
	\node[dummy] (d4) [above right=-0.64cm and -0.03cm of G] {};
	\node[branch] (d44) [right=of d4]{};
	\node[dummy] (d404) [below right=-0.64cm and -0.07cm of G]{};
	\node[branch] (d444) [right=of d404]{};
	\node[dummy] (d4444) [below=of d444]{};
	\node[dummy] (d5) [above left=-0.7cm and -0.07cm of G] {};
	\node[dummy] (d6) [above=of d44] {};
	\node[dummy] (d66) [above=of s1] {};
	\node[dummy] (y1) [right=of d44] {};
	\node[dummy] (y2) [right=of d444] {};
	\node[inout] (y_1) [ right=of d44] {$\mathbf{y_1}$};
	\node[inout] (y_1) [ right=of d444] {$\mathbf{y_2}$};


	\draw[connector] (r_1) -- (s1);
	\draw[connector] (r_2) -- (s2);
	
	\draw[thick] (s1) -- (K_1);
	\draw[connector] (K_1) -- node {$\mathbf{u_1}$} (d2);
	\draw[connector] (K_2) -- node {$\mathbf{u_2}$} (d3);
	\draw[thick] (s2) -- (K_2);
	

	\draw[thick] (d4) -- (d44);
	\draw[thick] (d404) -- (d444);

	\draw[connector] (d44)  --  (y1);
	\draw[thick] (d44)  --  (d6);
	\draw[thick] (d6)  --  (d66);
	\draw[connector] (d66)  --  (s1);
	
	\draw[connector] (d444)  --  (y2);
	\draw[thick] (d444)  --  (d4444);
	\draw[thick] (d4444)  --  (s22);
	\draw[connector] (s22)  --  (s2);
	\end{tikzpicture}
	\caption{Decentralized controller}
	\label{fig:decentralized_controller}
	\end{figure}